package lib.exporter;

import kernel.log.Log;

using tink.CoreApi;

class Export {
    private final exportConfig: ExportConfig;

    public function new(exportConfig: IExportable) {
        this.exportConfig = exportConfig.export();
    }

    public function handleRequest(req: Request): Response {
        switch (req.operation){
            case Get:
                return handleGet(req);
            case Set(value):
                //TODO: implement
                return NotFound;
        }
    }

    private function handleGet(request: Request): Response {
        if (!this.exportConfig.getDelegates.exists(request.field)){
            Log.warn('Requested get field ${request.field} does not exist in ??');
            return NotFound;
        }

        var delegate = this.exportConfig.getDelegates.get(request.field);
        var value = delegate(request.index);

        return Get(value);
    }
}
